from pynput import keyboard
import time
import _exceptions

_HIGHLIGHT = "\033[7m"
_RESET = "\033[0m"
_SPACES = "     "

def linear_buttons(buttons: list):
    global indexes
    indexes = _HIGHLIGHT

    for elements in buttons:
        if len(elements) < 2:
            raise _exceptions.MissingRequiredArgument("Missing arguments\nMust be ['button_name', 'function_name', 'function_arguments'=None]")
        elif len(elements) > 3:
            raise _exceptions.TooMuchArguments(
                "Useless arguments\nMust be ['button_name', 'function_name', 'function_arguments'=None]")

        indexes += f"[{elements[0]}]{_RESET}     "


    print(indexes, end='', flush=True)

    def _optn_index_get(list):
        global indexes

        for index, element in enumerate(list):
            if _HIGHLIGHT in element:
                return index

    def _optn_change_index(index_value):
        global indexes

        cleaned_selector = indexes.replace(_HIGHLIGHT, "").replace(_RESET, "")
        buttons_list = cleaned_selector.split(_SPACES)

        index = buttons_list[index_value]
        buttons_list[index_value] = f"{_HIGHLIGHT}{index}{_RESET}"

        indexes = "     ".join(buttons_list)
        print(f"\r{indexes}", end='', flush=True)

    def _optn_backward():
        global indexes

        current_index = _optn_index_get(indexes.split(_SPACES))
        if current_index - 1 < 0:
            _optn_change_index(len(indexes.split(_SPACES)) - 2)
        else:
            _optn_change_index(current_index - 1)

    def _optn_forward():
        global indexes

        current_index = _optn_index_get(indexes.split(_SPACES))
        if len(elements) > current_index + 1:
            _optn_change_index(current_index + 1)
        else:
            _optn_change_index(0)

    def _optn_execute_function():
        global indexes

        optn_index = _optn_index_get(indexes.split(_SPACES))
        function_to_execute = buttons[optn_index][1]
        print("\n", end="")

        if len(buttons[optn_index]) == 3:
            args = buttons[optn_index][2]
            function_to_execute(*args)
        else:
            function_to_execute()

        return True

    def _on_key_press(key):
        global indexes

        if key == keyboard.Key.left:
            _optn_backward()
        elif key == keyboard.Key.right:
            _optn_forward()
        elif key == keyboard.Key.enter:
            _optn_execute_function()
            exit()

    with keyboard.Listener(on_press=_on_key_press) as listener:
        listener.join()